unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Placemnt, RXSpin, RxGif, Mask, ToolEdit, StrUtils;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    ConvertBtn: TButton;
    FIndex: TRxSpinEdit;
    Label1: TLabel;
    Panel2: TPanel;
    FormStorage1: TFormStorage;
    FName: TEdit;
    Label2: TLabel;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    ScrollBox2: TScrollBox;
    Image2: TImage;
    Splitter1: TSplitter;
    Label3: TLabel;
    FileName: TEdit;
    FileDir: TDirectoryEdit;
    Label4: TLabel;
    CutEdges: TCheckBox;
    Label5: TLabel;
    AllFiles: TCheckBox;
    Label6: TLabel;
    procedure ConvertBtnClick(Sender: TObject);
    procedure FNameChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure WMF2GIF(F: String);
  end;

var
  Form1: TForm1;
  M: TMetaFile;
  FileName: String;

implementation

{$R *.DFM}

function  OS_isWindows95: boolean;  //true -    'Windows 95'
// 
begin
  if (GetVersion and $80000000) <> 0 then result:= true else result:= false;
end;

procedure SoundOff;
begin
  asm
    cli
    in      al,61h
    and     al,0fch
    out     61H,al
    sti
  end;
end;

procedure SoundOn;
begin
  asm
    cli
    in      al,61h
    or      al,3
    out     61H,al
    sti
  end;
end;

// Frequency -   ; Interval -   
procedure AsmBeep(Frequency: Word; Interval: Word);
var Period:Word;
begin
  if Frequency<19 then Frequency:=19;
  if Interval>10000 then Interval:=10000;
  if OS_isWindows95 then begin
    Period:=1193000 div Frequency;
    SoundOn;
    asm
      pushad
      cli
      mov     cx,Period
      in      al,61h
      or      al,3h
      out     61h,al
      mov     al,0b6h
      out     43h,al
      mov     al,cl
      out     42h,al
      mov     AL,ch
      out     42h,al
      sti
      popad
    end;
    Sleep(Interval);
    SoundOff;
  end else Windows.Beep(Frequency,Interval);
end;

procedure TForm1.WMF2GIF(F: String);
var W,H,WW,HH,LL,TT,X,Y: Integer; G: TGIFImage; C: TColor;
begin
  with Image1,Image1.Picture do
    try
      Screen.Cursor:=crHourGlass;
      LoadFromFile(F);
      W:=Metafile.Width;
      H:=Metafile.Height;
      WW:=2*W; HH:=2*H;
      Image1.Width:=W;
      Image1.Height:=H;
      Image1.Repaint;
      Image2.Width:=WW;                 //     
      Image2.Height:=HH;                //   Bitmap'
      Image2.Picture.Bitmap.Width:=WW;  //
      Image2.Picture.Bitmap.Height:=HH; //
      Image2.Picture.Bitmap.PixelFormat:=pf24bit; //   
      Image2.Picture.Bitmap.Canvas.StretchDraw(Rect(0,0,WW,HH),Metafile);
      if CutEdges.Checked then with Image2.Picture.Bitmap.Canvas do begin
        Y:=H;                //       
        C:=Pixels[0,Y];
        for X:=1 to W do if Pixels[X,Y]<C then begin LL:=X+1; break; end;
        for X:=2*W-1 downto W do if Pixels[X,Y]<C then begin WW:=X-LL; break; end;
        X:=W;
        for Y:=1 to H do if Pixels[X,Y]<C then begin TT:=Y+1; break; end;
        for Y:=2*H-1 downto H do if Pixels[X,Y]<C then begin HH:=Y-TT; break; end;
        CopyRect(Rect(0,0,WW-1,HH-1),Image2.Picture.Bitmap.Canvas,Rect(LL,TT,LL+WW-1,TT+HH-1));
        Image2.Picture.Bitmap.Width:=WW;
        Image2.Picture.Bitmap.Height:=HH;
        Image2.Width:=WW;
        Image2.Height:=HH;
      end;
      Image2.Repaint;
//      Image2.Picture.Bitmap.SaveToFile(FileName+'.bmp');
      G:=TGIFImage.Create;
      G.Assign(Image2.Picture.Bitmap);
      G.SaveToFile(ChangeFileExt(F,'.gif'));
      G.Free;
      Screen.Cursor:=crDefault;
      AsmBeep(1000,10);
    except
    end;
end;

procedure TForm1.ConvertBtnClick(Sender: TObject);
var F: String; SearchRec: TSearchRec; Founded: Integer;
begin
  ConvertBtn.Enabled:=False;
  F:=FileDir.Text;
  if F<>'' then F:=F+'\';
  if AllFiles.Checked then begin
    Founded:=FindFirst(F+'*.wmf',faAnyFile,SearchRec);
    while Founded=0 do begin
      FileName.Text:=ReplaceStr(ReplaceStr(SearchRec.Name,'.wmf',''),'.WMF','');
      FileName.Repaint;
      WMF2GIF(F+SearchRec.Name);
      Founded:=FindNext(SearchRec);
    end;
    FindClose(SearchRec);
    AsmBeep(1000,100);
    AsmBeep(5000,100);
    AsmBeep(2000,100);
    AsmBeep(500,100);
    AsmBeep(200,100);
  end else begin
    F:=FileName.Text+'.wmf';
    if FileExists(F) then WMF2GIF(F)
                     else ShowMessage('   "'+F+'"   !');
  end;
  ConvertBtn.Enabled:=True;
end;

procedure TForm1.FNameChange(Sender: TObject);
begin
  FileName.Text:=FName.Text+IntToStr(Round(FIndex.Value));
end;

end.
